mod fast;
mod dec_buf;

pub use self::fast::*;

use crate::se::Write;

pub trait PrimitiveRealSerializer<T> {
	fn serialize_real<W>(w: &mut W, i: T) -> Result<(), W::Error>
		where
			W: Write;
}

pub trait RealSerializer:
	PrimitiveRealSerializer<i8> +
	PrimitiveRealSerializer<i16> +
	PrimitiveRealSerializer<i32> + 
	PrimitiveRealSerializer<i64> +
	PrimitiveRealSerializer<u8> +
	PrimitiveRealSerializer<u16> +
	PrimitiveRealSerializer<u32> +
	PrimitiveRealSerializer<u64> +
	PrimitiveRealSerializer<f32> +
	PrimitiveRealSerializer<f64> {}