use crate::se::*;
use super::StringWriter;

pub fn default_base_serializer<W>(w: W) -> BaseSerializer<DefaultConfig, W>
	where W: Write
{
	BaseSerializer::new(w)
}

pub fn to_string<T>(value: T) -> Result<String, SerializerError>
	where T: Serialize
{
	let mut w = StringWriter::new();
	let mut s = default_base_serializer(&mut w);
	value.serialize(&mut s)?;
	Ok(w.to_string().unwrap())
}